Index: tmp/org.txm.partition.rcp/src/org/txm/partition/rcp/handlers/ComputePartitionDimensionsBarChart.java
===================================================================
--- tmp/org.txm.partition.rcp/src/org/txm/partition/rcp/handlers/ComputePartitionDimensionsBarChart.java	(revision 536)
+++ tmp/org.txm.partition.rcp/src/org/txm/partition/rcp/handlers/ComputePartitionDimensionsBarChart.java	(revision 537)
@@ -71,7 +71,6 @@
 		Object selection = this.getSelection(event);
 		PartitionDimensions partitionDimensions = null;
 		
-		
 		// Creating from Partition
 		if (selection instanceof Partition) {
 			Partition partition = (Partition) selection;
@@ -87,15 +86,12 @@
 			partitionDimensions = (PartitionDimensions) selection;
 		}
 
-//		final ChartEditorPart editor = SWTChartsComponentsProvider.getCurrent().openEditor(partitionDimensions, "Partition Dimensions Bar Chart"); //$NON-NLS-1$
 		
-		final ChartEditorPart editor = ChartEditorPart.openEditor(partitionDimensions); //$NON-NLS-1$
-		
 		// FIXME: Pie chart tests
-		//final ChartEditorPart editor2 = SWTChartsComponentsProvider.getCurrent().openEditor(partitionDimensions, "Partition Dimensions Pie Chart");
-
+//		partitionDimensions.setChartType("Partition Dimensions Pie Chart"); //$NON-NLS-1$
 		
-			
+		ChartEditorPart.compute(partitionDimensions); //$NON-NLS-1$
+
 		return null;
 	}
 	
Index: tmp/org.txm.partition.rcp/src/org/txm/partition/rcp/editors/PartitionDimensionsEditor.java
===================================================================
--- tmp/org.txm.partition.rcp/src/org/txm/partition/rcp/editors/PartitionDimensionsEditor.java	(revision 536)
+++ tmp/org.txm.partition.rcp/src/org/txm/partition/rcp/editors/PartitionDimensionsEditor.java	(revision 537)
@@ -9,9 +9,8 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.ToolItem;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
-import org.txm.core.preferences.TXMPreferences;
+import org.txm.partition.core.functions.PartitionDimensions;
 import org.txm.partition.core.preferences.PartitionDimensionsPreferences;
-import org.txm.partition.rcp.handlers.ComputePartitionDimensionsBarChart;
 import org.txm.partition.rcp.messages.PartitionUIMessages;
 import org.txm.rcp.IImageKeys;
 
@@ -33,7 +32,7 @@
 		// extend the tool bar
 		new ToolItem(this.getToolBar(), SWT.SEPARATOR);
 		final ToolItem sortByPartSize = new ToolItem(this.getToolBar(), SWT.CHECK);
-		sortByPartSize.setImage(IImageKeys.getImage(ComputePartitionDimensionsBarChart.class, "icons/silk_sort_by_size.png"));
+		sortByPartSize.setImage(IImageKeys.getImage(this.getClass(), "icons/silk_sort_by_size.png"));
 		sortByPartSize.setToolTipText(PartitionUIMessages.PreferencesPage_DIMENSIONS_SORT_BY_PARTS_SIZE);
 		sortByPartSize.setSelection(this.getBooleanParameterValue(PartitionDimensionsPreferences.CHART_DIMENSIONS_SORTED_BY_SIZE));
 		
@@ -41,7 +40,7 @@
 			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				TXMPreferences.putLocal(getResultData(), PartitionDimensionsPreferences.CHART_DIMENSIONS_SORTED_BY_SIZE, sortByPartSize.getSelection());
+				((PartitionDimensions)getResultData()).setParameters(sortByPartSize.getSelection());
 				computeChart(true, false, true);
 			}
 			
Index: tmp/org.txm.chartsengine.raster.rcp/src/org/txm/chartsengine/raster/rcp/RasterImageChartsComponentProvider.java
===================================================================
--- tmp/org.txm.chartsengine.raster.rcp/src/org/txm/chartsengine/raster/rcp/RasterImageChartsComponentProvider.java	(revision 536)
+++ tmp/org.txm.chartsengine.raster.rcp/src/org/txm/chartsengine/raster/rcp/RasterImageChartsComponentProvider.java	(revision 537)
@@ -44,7 +44,7 @@
 
 	@Override
 	public ChartEditorInput createChartEditorInput(ChartResult result) {
-		ChartCreator chartCreator = this.getChartsEngine().getChartCreator(result.getClass(), result.getChartType());
+		ChartCreator chartCreator = this.getChartsEngine().getChartCreator(result);
 		File file = chartCreator.createChartFile(result);
 		// FIXME : to temporary restore the PS and PDF formats : need to be recoded if we decide to keep the PDF and PS view else to remove if we decide to keep only the feature as export
 		if(this.chartsEngine.getOutputFormat() == ChartsEngine.OUTPUT_FORMAT_PS || this.chartsEngine.getOutputFormat() == ChartsEngine.OUTPUT_FORMAT_PDF)	{
Index: tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 536)
+++ tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 537)
@@ -953,15 +953,14 @@
 
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
-		this.parameters = parameters;
 		try {
 			Corpus corpus = this.getCorpus();
 			boolean includeXpivot = (Boolean) this.getBooleanParameterValue(CooccurrencePreferences.INCLUDE_X_PIVOT);
-			Query query = new Query(this.parameters.get(CooccurrencePreferences.QUERY).toString());
+			Query query = new Query(parameters.get(CooccurrencePreferences.QUERY).toString());
 
 			StructuralUnit limit = corpus.getStructuralUnit(this.getStringParameterValue(CooccurrencePreferences.LIMIT));
 
-			List<Property> properties = (List<Property>)this.parameters.get(CooccurrencePreferences.PROPERTIES);
+			List<Property> properties = (List<Property>)parameters.get(CooccurrencePreferences.PROPERTIES);
 
 			int maxLeft = this.getIntParameterValue(CooccurrencePreferences.MAX_LEFT);
 			int minLeft = this.getIntParameterValue(CooccurrencePreferences.MIN_LEFT);
Index: tmp/org.txm.chartsengine.r.core/src/org/txm/chartsengine/r/core/themes/DefaultTheme.java
===================================================================
--- tmp/org.txm.chartsengine.r.core/src/org/txm/chartsengine/r/core/themes/DefaultTheme.java	(revision 536)
+++ tmp/org.txm.chartsengine.r.core/src/org/txm/chartsengine/r/core/themes/DefaultTheme.java	(revision 537)
@@ -50,7 +50,7 @@
 		1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3 }; 
 
 	/** The monowidths. */
-	public static int[] monowidths = {
+	public static int[] monoWidths = {
 		1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }; 
 
 	public DefaultTheme() {
Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 536)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 537)
@@ -848,8 +848,6 @@
 
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
-		this.parameters = parameters;
-
 		try {
 			List<Property> props = (List<Property>) parameters.get("props");
 			Query query = (Query) parameters.get("query");
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 536)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 537)
@@ -25,59 +25,78 @@
 	protected String chartType;
 	
 	/**
+	 * The chart dirty state.
+	 */
+	protected boolean chartDirty;
+	
+	/**
 	 * 
 	 * @param parent
 	 */
 	public ChartResult(TXMResult parent) {
 		super(parent);
+		this.chartDirty = true;
 	}
 	
 	
-	@Override
-	public Object clone() {
-		ChartResult clone = null;
-	    try {
-			clone = (ChartResult) super.clone();
-		}
-		catch(Exception e) {
-		}
-	    return clone;
+	public ChartResult() {
+		this(null);
 	}
 	
-	/**
-	 * 
-	 * @param update
-	 * @return
-	 * @throws Exception
-	 */
+
 	public boolean computeChart(boolean update) throws Exception {
 
-		ChartCreator chartCreator = ChartsEngine.getCurrent().getChartCreator(this.getClass(), chartType);
+		this.subTask("computing chart");
+
+		// FIXME: Debug
+		System.err.println("ChartResult.computeChart(): computing chart of type " + this.getClass() + "...");
+
+		if(!this.chartDirty)	{
+			
+			// FIXME: Debug
+			System.err.println("ChartResult.computeChart(): chart is not dirty, computing aborted.");
+
+			return false;
+		}
+
+		
+		ChartCreator chartCreator = ChartsEngine.getCurrent().getChartCreator(this);
 		if(chartCreator != null)	{
 			
 			if(update)	{
 				// FIXME: debug
-				System.err.println("ChartResult._compute(): updating chart.");
+				System.err.println("ChartResult.computeChart(): updating chart.");
 				
 				chartCreator.updateChart(this.chart, this);
 			}
 			else	{
 				
 				// FIXME: debug
-				System.err.println("ChartResult._compute(): creating chart.");
+				System.err.println("ChartResult.computeChart(): creating chart.");
 				
 				this.chart =  chartCreator.createChart(this);				
 			}
 			
-			this.dirty = false;
+			this.chartDirty = false;
 			return true;
 			
 		}
 		return false;
 	}
 	
+	@Override
+	public Object clone() {
+		ChartResult clone = null;
+	    try {
+			clone = (ChartResult) super.clone();
+			clone.chart = null;
+			clone.chartDirty = true;
+		}
+		catch(Exception e) {
+		}
+	    return clone;
+	}
 	
-	
 	/**
 	 * @return the chart
 	 */
@@ -104,6 +123,27 @@
 		}
 		this.chartType = chartType;
 	}
+
+
+	/**
+	 * @return the chartDirty
+	 */
+	public boolean isChartDirty() {
+		return chartDirty;
+	}
+
+	@Override
+	public void setDirty() {
+		super.setDirty();
+		this.setChartDirty();
+	}
+
+	/**
+	 * 
+	 */
+	public void setChartDirty() {
+		this.chartDirty = true;
+	}
 	
 	
 
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java	(revision 536)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java	(revision 537)
@@ -93,6 +93,7 @@
 	/**
 	 * UI related, this preference can be used to tell if the chart must be updated directly after editing a widget value or only after pressed a "Compute" button.
 	 */
+	//FIXME: this preference is not used at this time, see if it's useless or not.
 	protected boolean directComputing; 
 
 	/**
@@ -107,38 +108,49 @@
 		this.description = description;
 		this.outputFormat = outputFormat;
 		this.theme = new Theme();
+		//FIXME: this preference is not used at this time, see if it's useless or not.
 		this.directComputing = true;
 		Log.warning("Starting Charts Engine: " + this);
 	}
 
 	/**
-	 * Gets a chart creator for the specified result data type and chart type.
+	 * Gets a chart creator for the specified result.
 	 * @param resultDataType
 	 * @param chartType
 	 * @return A chart creator if it exists otherwise <code>null</code>
 	 */
-	public ChartCreator getChartCreator(Class resultDataType, String chartType)	{
+	public ChartCreator getChartCreator(ChartResult result, String chartType)	{
 		ChartCreator chartCreator = null;
-		HashMap<String, ChartCreator> map = this.chartCreators.get(resultDataType);
+		HashMap<String, ChartCreator> map = this.chartCreators.get(result.getClass());
 		if(map != null)	{
 			chartCreator = map.get(chartType);
 		}
 		
 		if(chartCreator == null)	{
-			Log.warning(this.name + ": No chart creator can be found for result: " + resultDataType + " and chart type: " + chartType);
+			Log.warning(this.name + ": No chart creator can be found for result: " + result.getClass() + " and chart type: " + chartType);
 		}
 		return chartCreator;
 	}
 	
 	/**
-	 * Gets a chart creator for the specified result data type.
+	 * Gets a chart creator for the specified result.
 	 * @param resultDataType
 	 * @return A chart creator if it exists otherwise <code>null</code>
 	 */
+	public ChartCreator getChartCreator(ChartResult result)	{
+		return this.getChartCreator(result, result.getChartType());
+	}
+
+	/**
+	 *  Gets a chart creator for the specified result data type.
+	 * @param resultDataType
+	 * @return
+	 */
 	public ChartCreator getChartCreator(Class resultDataType)	{
-		return this.getChartCreator(resultDataType, null);
+		return this.getChartCreator(resultDataType);
 	}
 
+	
 	/**
 	 * Gets a list of all installed chart creators for the specified result. 
 	 * @param resultDataType
@@ -181,7 +193,7 @@
 		
 		log +=".";
 		
-		Log.warning(log);
+		Log.info(log);
 		
 	}
 
@@ -191,8 +203,8 @@
 	 * @param chartType
 	 * @return <code>True</code> if a chart creator can be found, otherwise <code>false</code>
 	 */
-	public boolean canCreateChart(Class resultDataType, String chartType)	{
-		return this.getChartCreator(resultDataType, chartType) != null;
+	public boolean canCreateChart(ChartResult result, String chartType)	{
+		return this.getChartCreator(result, chartType) != null;
 	}
 
 	/**
@@ -200,8 +212,8 @@
 	 * @param resultDataType
 	 * @return <code>True</code> if a chart creator can be found, otherwise <code>false</code>
 	 */
-	public boolean canCreateChart(Class resultDataType)	{
-		return this.getChartCreator(resultDataType) != null;
+	public boolean canCreateChart(ChartResult result)	{
+		return this.getChartCreator(result) != null;
 	}
 	
 	/**
@@ -563,7 +575,7 @@
 	 */
 	public Object createChart(ChartResult result, String chartType)	{
 		Object chart = null;
-		ChartCreator chartCreator = this.getChartCreator(result.getClass(), chartType);
+		ChartCreator chartCreator = this.getChartCreator(result, chartType);
 		if(chartCreator != null)	{
 			chart = chartCreator.createChart(result);
 		}
@@ -588,7 +600,7 @@
 	 * @param result
 	 */
 	public void updateChart(Object chart, ChartResult result)	{
-		ChartCreator chartCreator = this.getChartCreator(result.getClass(), result.getChartType());
+		ChartCreator chartCreator = this.getChartCreator(result, result.getChartType());
 		if(chartCreator != null)	{
 			chartCreator.updateChart(chart, result);
 		}
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java	(revision 536)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java	(revision 537)
@@ -143,7 +143,6 @@
 	
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
-		this.parameters = parameters;
 		try {
 			Integer max = null;
 			Object o = parameters.get(CQPPreferences.MAXVALUE);
Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 536)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 537)
@@ -1,6 +1,3 @@
-/**
- * 
- */
 package org.txm.core.results;
 
 import java.io.File;
@@ -65,8 +62,6 @@
 	 */
 	protected boolean visible;
 
-	protected TXMParameters parameters = null;
-
 	/**
 	 * The command preferences node qualifier.
 	 */
@@ -92,19 +87,6 @@
 	 * @param parent
 	 */
 	public TXMResult(TXMResult parent) {
-		this(parent, null);
-	}
-
-	/**
-	 * Creates a new TXMResult, child of the specified parent.
-	 * 
-	 * @param parent
-	 * @param parameters
-	 */
-	public TXMResult(TXMResult parent, TXMParameters parameters) {
-
-		// FIXME: discuss about this method and validate it. Also discuss about
-		// a getInternalName() method that should also return an unique ID.
 		this.parent = parent;
 		this.createUUID();
 
@@ -115,16 +97,27 @@
 		}
 		this.children = new ArrayList<TXMResult>(1);
 		this.preferencesNodeQualifier = FrameworkUtil.getBundle(getClass()).getSymbolicName();
-		this.parameters = parameters;
 
 		this.constructorCalled = true; // if not set the compute method will
 										// always return false
 		// FIXME: Debug
 		// System.out.println("TXMResult.TXMResult(): default preferences node qualifier = "
 		// + this.preferencesNodeQualifier + ", class = " + getClass());
+
+		this.dirty = true;
 	}
 
 	/**
+	 * Creates a new TXMResult, child of the specified parent.
+	 * 
+	 * @param parent
+	 * @param parameters
+	 */
+	public TXMResult(TXMResult parent, TXMParameters parameters) {
+
+	}
+
+	/**
 	 * Creates and stores an UUID dedicated to persistence for this result.
 	 */
 	protected void createUUID() {
@@ -187,7 +180,7 @@
 	 * @return
 	 */
 	public int getIntParameterValue(String key) {
-		return TXMPreferences.getInt(key, this.parameters, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getInt(key, this, this.preferencesNodeQualifier);
 	}
 
 	/**
@@ -198,7 +191,7 @@
 	 * @return
 	 */
 	public float getFloatParameterValue(String key) {
-		return TXMPreferences.getFloat(key, this.parameters, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getFloat(key, this, this.preferencesNodeQualifier);
 	}
 
 	/**
@@ -209,7 +202,7 @@
 	 * @return
 	 */
 	public double getDoubleParameterValue(String key) {
-		return TXMPreferences.getDouble(key, this.parameters, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getDouble(key, this, this.preferencesNodeQualifier);
 	}
 
 	/**
@@ -220,7 +213,7 @@
 	 * @return
 	 */
 	public boolean getBooleanParameterValue(String key) {
-		return TXMPreferences.getBoolean(key, this.parameters, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getBoolean(key, this, this.preferencesNodeQualifier);
 	}
 
 	/**
@@ -231,7 +224,7 @@
 	 * @return
 	 */
 	public long getLongParameterValue(String key) {
-		return TXMPreferences.getLong(key, this.parameters, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getLong(key, this, this.preferencesNodeQualifier);
 	}
 
 	/**
@@ -242,17 +235,14 @@
 	 * @return
 	 */
 	public String getStringParameterValue(String key) {
-		return TXMPreferences.getString(key, this.parameters, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getString(key, this, this.preferencesNodeQualifier);
 	}
 
 	/**
-	 * Read the parameter stored in the Java class membres : the pXXXXX named
-	 * members
+	 * Copies the parameters stored in the Java class members : the pXXXXX named members to the local preferences node.
+	 * Commands must define this method to persist their parameters.
+	 * Just returns <b>true</b> if you don't want to bother with this.
 	 * 
-	 * Commands must define this method to persist their parameters
-	 * 
-	 * just return 'true' if you don't want to bother with this
-	 * 
 	 * @return
 	 */
 	public boolean saveParameters() {
@@ -288,7 +278,7 @@
 			this.parent = null;
 			return true;
 		} catch (NullPointerException e) {
-			// do nothing
+			// does nothing
 		} catch (Exception e) {
 			e.printStackTrace();
 		}
@@ -727,15 +717,31 @@
 		// FIXME: Debug
 		System.err.println("TXMResult.compute(): computing result of type " + this.getClass() + "...");
 
-		if (!hasBeenConstructorCalled()) {
+		if(!this.isDirty())	{
+			
+			// FIXME: Debug
+			System.err.println("TXMResult.compute(): result is not dirty, computing skipped.");
+
+			return true;
+		}
+		
+		
+		if(!hasBeenConstructorCalled())	{
 			return false;
 		}
 
 		if (!canCompute()) {
+			// FIXME: Debug
+			System.err.println("TXMResult.compute(): missing or wrong parameters, computing aborted.");
+
 			return false;
 		}
 
 		if (!_compute(update)) {
+			
+			// FIXME: Debug
+			System.err.println("TXMResult.compute(): computing failed.");
+			
 			return false;
 		}
 
@@ -783,14 +789,12 @@
 		return constructorCalled;
 	}
 
-	// /**
-	// * Copy the parameters from the local preference node if exists. Also
-	// fills the non existent parameters with the command default preferences.
-	// * @return
-	// */
-	// public abstract boolean loadParameters();
-
 	/**
+	 * Copies the parameters from the local preference node if exists. Also fills the non existent parameters with the command default preferences.
+	 */
+	//public abstract void loadParameters();
+	
+	/**
 	 * 
 	 * @return the array of extensions to show in the FileDialog SWT widget
 	 */
